/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-fingertip-pressure-1.8.15-0quantal-20150620-1528/msg/PressureInfoElement.msg
 *
 */


#ifndef FINGERTIP_PRESSURE_MESSAGE_PRESSUREINFOELEMENT_H
#define FINGERTIP_PRESSURE_MESSAGE_PRESSUREINFOELEMENT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>

namespace fingertip_pressure
{
template <class ContainerAllocator>
struct PressureInfoElement_
{
  typedef PressureInfoElement_<ContainerAllocator> Type;

  PressureInfoElement_()
    : frame_id()
    , center()
    , halfside1()
    , halfside2()
    , force_per_unit()  {
    }
  PressureInfoElement_(const ContainerAllocator& _alloc)
    : frame_id(_alloc)
    , center(_alloc)
    , halfside1(_alloc)
    , halfside2(_alloc)
    , force_per_unit(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _frame_id_type;
  _frame_id_type frame_id;

   typedef std::vector< ::geometry_msgs::Vector3_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::geometry_msgs::Vector3_<ContainerAllocator> >::other >  _center_type;
  _center_type center;

   typedef std::vector< ::geometry_msgs::Vector3_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::geometry_msgs::Vector3_<ContainerAllocator> >::other >  _halfside1_type;
  _halfside1_type halfside1;

   typedef std::vector< ::geometry_msgs::Vector3_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::geometry_msgs::Vector3_<ContainerAllocator> >::other >  _halfside2_type;
  _halfside2_type halfside2;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _force_per_unit_type;
  _force_per_unit_type force_per_unit;




  typedef boost::shared_ptr< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PressureInfoElement_

typedef ::fingertip_pressure::PressureInfoElement_<std::allocator<void> > PressureInfoElement;

typedef boost::shared_ptr< ::fingertip_pressure::PressureInfoElement > PressureInfoElementPtr;
typedef boost::shared_ptr< ::fingertip_pressure::PressureInfoElement const> PressureInfoElementConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace fingertip_pressure

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'fingertip_pressure': ['/tmp/buildd/ros-hydro-fingertip-pressure-1.8.15-0quantal-20150620-1528/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1cb486bb542ab85e1ff8d84fe9cc899f";
  }

  static const char* value(const ::fingertip_pressure::PressureInfoElement_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1cb486bb542ab85eULL;
  static const uint64_t static_value2 = 0x1ff8d84fe9cc899fULL;
};

template<class ContainerAllocator>
struct DataType< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "fingertip_pressure/PressureInfoElement";
  }

  static const char* value(const ::fingertip_pressure::PressureInfoElement_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string frame_id # Frame ID\n\
geometry_msgs/Vector3[] center # Corner of sensor (meters)\n\
geometry_msgs/Vector3[] halfside1 # Half of one edge of sensor (meters)\n\
geometry_msgs/Vector3[] halfside2 # Half of perpendicular edge of sensor (meters)\n\
# Sensor corners are at center+-halfside1+-halfside2\n\
# Cross product of halfside1 and halfside2 points out\n\
float64[] force_per_unit # Multiply this by the raw sensor value to get a force\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const ::fingertip_pressure::PressureInfoElement_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.frame_id);
      stream.next(m.center);
      stream.next(m.halfside1);
      stream.next(m.halfside2);
      stream.next(m.force_per_unit);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PressureInfoElement_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::fingertip_pressure::PressureInfoElement_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::fingertip_pressure::PressureInfoElement_<ContainerAllocator>& v)
  {
    s << indent << "frame_id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.frame_id);
    s << indent << "center[]" << std::endl;
    for (size_t i = 0; i < v.center.size(); ++i)
    {
      s << indent << "  center[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "    ", v.center[i]);
    }
    s << indent << "halfside1[]" << std::endl;
    for (size_t i = 0; i < v.halfside1.size(); ++i)
    {
      s << indent << "  halfside1[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "    ", v.halfside1[i]);
    }
    s << indent << "halfside2[]" << std::endl;
    for (size_t i = 0; i < v.halfside2.size(); ++i)
    {
      s << indent << "  halfside2[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "    ", v.halfside2[i]);
    }
    s << indent << "force_per_unit[]" << std::endl;
    for (size_t i = 0; i < v.force_per_unit.size(); ++i)
    {
      s << indent << "  force_per_unit[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.force_per_unit[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // FINGERTIP_PRESSURE_MESSAGE_PRESSUREINFOELEMENT_H
